;(function ($) {

  "use strict";
  var text = "";
  var msnry;

  function msToTime(duration) {
    var milliseconds = parseInt((duration % 1000) / 100),
      seconds = Math.floor((duration / 1000) % 60),
      minutes = Math.floor((duration / (1000 * 60)) % 60),
      hours = Math.floor((duration / (1000 * 60 * 60)) % 24);

    hours = (hours < 10) ? "0" + hours : hours;
    minutes = (minutes < 10) ? "0" + minutes : minutes;
    seconds = (seconds < 10) ? "0" + seconds : seconds;

    return hours + ":" + minutes + ":" + seconds + "." + milliseconds;
  }

  var calDate = function (date1) {
    var today = new Date();
    date1 = new Date(date1);
    const diffTime = Math.abs(today - date1);
    const diffDays = Math.ceil(diffTime / (1000 * 60 * 60 * 24));

    var dd = String(date1.getDate()).padStart(2, '0');
    var mm = String(date1.getMonth() + 1).padStart(2, '0'); //January is 0!
    var yyyy = date1.getFullYear();

    if (diffDays > 30)
      return yyyy + "-" + mm + "-" + dd;
    else if (diffDays > 0 && diffDays <= 30)
      return diffDays + text;
    else return msToTime(diffTime);
  }

  String.prototype.toHHMMSS = function () {
    var sec_num = parseInt(this, 10); // don't forget the second param
    var hours = Math.floor(sec_num / 3600);
    var minutes = Math.floor((sec_num - (hours * 3600)) / 60);
    var seconds = sec_num - (hours * 3600) - (minutes * 60);

    if (hours < 10) {
      hours = "0" + hours;
    }
    if (minutes < 10) {
      minutes = "0" + minutes;
    }
    if (seconds < 10) {
      seconds = "0" + seconds;
    }
    return hours + ':' + minutes + ':' + seconds;
  }

  /*
   * using 'video_url' (dynamic information) to get youtube video basic informations (title, duration).
   */

  var tfcounter = function () {
    $('.fel-ytLoadMore').on('click', function () {
      var token = $('.fel-ytNextpage')[0].innerText;
      var chanel = $(this).data('chanel');
      var max = $(this).data('max');
      var order = $(this).data('order');
      var key = $(this).data('key');
      var logo = $(this).data('logo');
      var title = $(this).data('title');
      var style = $(this).data('style');
      var playlist = $(this).data('playlist');
      var layout = $(this).data('layout');
      text = $(this).data('text');
      $('.fel-ytLoader').addClass('is-active');

      if (style == "style1") {
        // run GET request on API
        $.get(
          "https://www.googleapis.com/youtube/v3/search", {
            part: 'snippet, id',
            channelId: chanel,
            pageToken: token,
            type: 'video',
            key: key,
            order: order,
            maxResults: max,
          },
          function (data) {
            var nextPageToken = data.nextPageToken;
            var prevPageToken = data.prevPageToken;

            // lod search data
            var items = data.items;
            var _html = "";
            for (var i = 0; i < items.length; i++) {
              var video_title = items[i].snippet.title;
              var video_desc = items[i].snippet.description;

              $.get(
                "https://www.googleapis.com/youtube/v3/videos", {
                  id: items[i].id.videoId,
                  part: 'contentDetails,statistics',
                  key: key,
                },
                function (data) {
                  setTimeout(function () {
                    var item = data.items[0];
                    var regExp = /PT(\d+)M(\d+)S/;
                    var match = item.contentDetails.duration.match(regExp);
                    console.log($('#' + item.id));
                    $('#' + item.id).find('.fel-ytWrap__time').empty().append(match[1] + ':' + match[2]);
                    $('#' + item.id).find('.fel-ytWrap__views span').empty().append(item.statistics.viewCount);
                    $('#' + item.id).find('.fel-ytWrap__like span').empty().append(item.statistics.likeCount);
                    $('#' + item.id).find('.fel-ytWrap__comments span').empty().append(item.statistics.commentCount);

                  }, 1000);
                });

              _html += " <div class='fel-ytWrap__item' id='" + items[i].id.videoId + "'>" +
                "<div class='fel-ytWrap__meta'>" +
                "<div class='fel-ytWrap__avarta'>" +
                "<img src='" + logo + "' alt='" + title + "'>" +
                "<span>" + title + "</span>" +
                "</div>" +

                "<div class='fel-ytWrap__date'>" +
                calDate(items[i].snippet.publishedAt)
                + "</div>" +
                "</div>" +

                "<div class='fel-ytWrap__item__info'>" +
                "<div class='fel-ytWrap__video'>";

              if (layout == 'videoinline')
                _html += "<iframe src='https://www.youtube.com/embed/" + items[i].id.videoId + "' frameborder='0' allow='accelerometer; autoplay; encrypted-media; gyroscope; picture-in-picture' allowfullscreen></iframe>";
              else if (layout == 'newtab')
                _html += "<a href='https://www.youtube.com/watch?v=" + items[i].id.videoId + "' title='" + video_title + "' target='_blank'>" +
                  "<img src='" + items[i].snippet.thumbnails.high.url + "' alt='" + video_title + "'>" +
                  "<span class='fel-ytWrap__time'>00:00</span>" +
                  "<span class='fel-ytWrap__icon'><i class='eicon-play'></i></span>" +
                  "</a>";
              else
                _html += "<div data-id='" + items[i].id.videoId + "' class='fel-ytShowPopup'>\n" +
                  "                  <img src='" + items[i].snippet.thumbnails.high.url + "' alt='" + video_title + "'>\n" +
                  "                                      <span class='fel-ytWrap__time'>00:00</span>\n" +
                  "                                    <span class='fel-ytWrap__icon'><i class='eicon-play'></i></span>\n" +
                  "                </div>";
              _html += "</div>" +
                "<h3><a href='https://www.youtube.com/watch?v=" + items[i].id.videoId + "' title='" + video_title + "' target='_blank'>" + video_title + "</a></h3>" +
                "<p>" + video_desc + "</p>" +
                "<div class='fel-ytWrap__details'>" +
                "<span class='fel-ytWrap__views'><span>0</span> <i class='eicon-preview-medium'></i></span>" +
                "<span class='fel-ytWrap__like'><span>0</span> <i class='eicon-facebook-like-box'></i></span>" +
                "<span class='fel-ytWrap__comments'><span>0</span> <i class='eicon-comments'></i></span>" +
                "</div>" +
                "</div>" +
                "</div>";
            }

            var $items = _html;
            var $grid = $('.fel-ytWrap__content--masory');
            $grid.append($items).each(function () {
              $grid.masonry('reloadItems');
            });
            setTimeout(function () {
              $grid.masonry('layout');
              $('.fel-ytLoader').removeClass('is-active');
            }, 1500);
          }
        );
      }

      if (style == "style2") {
        // run GET request on API
        $.get(
          "https://www.googleapis.com/youtube/v3/playlistItems", {
            part: 'snippet,contentDetails',
            playlistId: playlist,
            key: key,
            pageToken: token,
            order: order,
            maxResults: max,
          },
          function (data) {
            var nextPageToken = data.nextPageToken;
            var prevPageToken = data.prevPageToken;

            // lod search data
            var items = data.items;
            var _html = "";
            for (var i = 0; i < items.length; i++) {
              var video_title = items[i].snippet.title;
              var video_desc = items[i].snippet.description;

              $.get(
                "https://www.googleapis.com/youtube/v3/videos", {
                  id: items[i].id.videoId,
                  part: 'contentDetails,statistics',
                  key: key,
                },
                function (data) {
                  setTimeout(function () {
                    var item = data.items[0];
                    var regExp = /PT(\d+)M(\d+)S/;
                    var match = item.contentDetails.duration.match(regExp);
                    console.log($('#' + item.id));
                    $('#' + item.id).find('.fel-ytWrap__time').empty().append(match[1] + ':' + match[2]);
                    $('#' + item.id).find('.fel-ytWrap__views span').empty().append(item.statistics.viewCount);
                    $('#' + item.id).find('.fel-ytWrap__like span').empty().append(item.statistics.likeCount);
                    $('#' + item.id).find('.fel-ytWrap__comments span').empty().append(item.statistics.commentCount);

                  }, 1000);
                });

              _html += " <div class='fel-ytWrap__item' id='" + items[i].id.videoId + "'>" +
                "<div class='fel-ytWrap__meta'>" +
                "<div class='fel-ytWrap__avarta'>" +
                "<img src='" + logo + "' alt='" + title + "'>" +
                "<span>" + title + "</span>" +
                "</div>" +

                "<div class='fel-ytWrap__date'>" +
                calDate(items[i].snippet.publishedAt)
                + "</div>" +
                "</div>" +

                "<div class='fel-ytWrap__item__info'>" +
                "<div class='fel-ytWrap__video'>" +
                "<iframe src='https://www.youtube.com/embed/" + items[i].id.videoId + "' frameborder='0' allow='accelerometer; autoplay; encrypted-media; gyroscope; picture-in-picture' allowfullscreen></iframe>" +

                "<a href='https://www.youtube.com/watch?v=" + items[i].id.videoId + "' title='" + video_title + "' target='_blank'>" +
                "<img src='" + items[i].snippet.thumbnails.high.url + "' alt='" + video_title + "'>" +
                "<span class='fel-ytWrap__time'>00:00</span>" +
                "<span class='fel-ytWrap__icon'><i class='eicon-play'></i></span>" +
                "</a>" +
                "</div>" +
                "<h3><a href='https://www.youtube.com/watch?v=" + items[i].id.videoId + "' title='" + video_title + "' target='_blank'>" + video_title + "</a></h3>" +
                "<p>" + video_desc + "</p>" +
                "<div class='fel-ytWrap__details'>" +
                "<span class='fel-ytWrap__views'><span>0</span> <i class='eicon-preview-medium'></i></span>" +
                "<span class='fel-ytWrap__like'><span>0</span> <i class='eicon-facebook-like-box'></i></span>" +
                "<span class='fel-ytWrap__comments'><span>0</span> <i class='eicon-comments'></i></span>" +
                "</div>" +
                "</div>" +
                "</div>";
            }


            var $items = _html;
            var $grid = $('.fel-ytWrap__content--masory');
            $grid.append($items).each(function () {
              $grid.masonry('reloadItems');
            });
            setTimeout(function () {
              $grid.masonry('layout');
              $('.fel-ytLoader').removeClass('is-active');
            }, 1500);

          }
        );
      }
    })

    $(document).ready(function () {
      setTimeout(function () {
        msnry = $('.fel-ytWrap__content--masory');
        msnry.masonry({
          itemSelector: '.fel-ytWrap__item',
          percentPosition: true,
          columnWidth: '.fel-ytWrap__item',
          gutter: msnry.data('gutter')
        });
      }, 2000);
    });

    $(".fel-ytPopup__content").fitVids();
    $('.fel-ytOverlay, .fel-ytClose').on('click', function () {
      $('.fel-ytPopup').removeClass('is-active');
      $('.fel-ytOverlay').removeClass('is-active');
    })

    $('.fel-ytShowPopup').on('click', function () {
      $('.fel-ytPopup__content').empty().append('<iframe src="https://www.youtube.com/embed/' + $(this).data('id') + '" frameborder="0" allow="accelerometer; autoplay; encrypted-media; gyroscope; picture-in-picture"></iframe>');
      $(".fel-ytPopup__content").fitVids();
      $('.fel-ytPopup').addClass('is-active');
      $('.fel-ytOverlay').addClass('is-active');
    })

    //slide
    var nav_prev = $('.fel-ytWrap__content').data('prev'),
      nav_next = $('.fel-ytWrap__content').data('next'),
      distant = $('.fel-ytWrap__content').data('distant'),
      items = $('.fel-ytWrap__content').data('items');

    if ($('.fel-ytWrap__headTab').length == 0)
      initialize_owl($('.fel-ytWrap__content.owl-carousel'));

    //tab
    if ($('.fel-ytWrap__headTab').length) {
      $('.fel-ytWrap__headTab span').on('click', function () {
        $(this).addClass('active').siblings().removeClass('active');
        var id = $(this).data('id');
        $(id).addClass('active').siblings().removeClass('active');
        var tabs = $(id).siblings();
        for (var i = 0; i < tabs.length; i++)
          destroy_owl($(tabs[i]).find('.owl-carousel'));
        initialize_owl($(id).find('.owl-carousel'));
      })

      $('.fel-ytWrap__headTab span:first').addClass('active');
      $('#content0').addClass('active');
      initialize_owl($('#content0 .owl-carousel'));
    }

    function initialize_owl(el) {
      var owl = el.owlCarousel({
        loop: true,
        nav: true,
        responsive: {
          0: {
            items: 1,
            margin: 0
          },
          600: {
            items: 2,
            margin: distant
          },
          1023: {
            items: items,
            margin: distant
          }
        },
        navText: ["<i class='" + nav_prev + "'></i>", "<i class='" + nav_next + "'></i>"]
      });
    }

    function destroy_owl(el) {
      el.owlCarousel('destroy');
    }

    $('.fel-ytWrap__tabContent .fel-ytWrap__video').css('height', $('.fel-ytWrap__tabContent .fel-ytWrap__item__info:first').outerWidth() * 0.7)
    $('.owl-carousel.fel-ytWrap__content .fel-ytWrap__video').css('height', $('.owl-carousel.fel-ytWrap__content .fel-ytWrap__item__info:first').outerWidth() * 0.7)
  }

  $(window).on('elementor/frontend/init', function () {
    elementorFrontend.hooks.addAction('frontend/element_ready/tfyoutube.default', tfcounter);
  });
})(jQuery);